# abgleitet von:
# URI::WithBase  -> URI::URL -> web::URL
package web::URL;
#use URI::URL;
use strict;
use warnings;
use base 'URI::URL';
use Data::Dumper;

require Exporter;
*import = \&Exporter::import;
our @EXPORT = qw(url);

# Easy to use constructor
# Da url sowohl als Klassen methode
# als auch als exportierete funktion aufrufabr ist
# muß verifziert werden wie der aufruf geschah
# dazu prüfe ich ob "$class" ein Objekt ist (ref)
# oder der Klassenname "web::URL"
# ansonsten muß es die URL sein.
sub url ($;$)
{
  my $class=shift;
  if($class)
  {
    if(ref($class))
    { $class='web::URL'; }
    else
    { unshift(@_,$class) unless($class eq 'web::URL'); }
  }
  else
  { $class='web::URL'; }
  $class->new(@_);
}


########################################################################
# overload
sub new
{
  my $class = shift;
  my $self=undef;
  if(ref($class))
  {
    #print "NEW1: ".Dumper($class);
    $self =  ref($class)->SUPER::new(@_,$class->abs());
    if(ref($class) eq __PACKAGE__)
    {
      $self->[2]=$class->deep()+1;
      $self->[3]=$class->abs()->as_string();
    }
    else
    {
      $self->[2]=-1;
      $self->[3]=undef;
    }
    #print "NEW1: ".Dumper($self);
  }
  else
  {
    $self = $class->SUPER::new(@_);
    $self->[2]=-1;
    $self->[3]=undef;
    #print "NEW2: ".Dumper($self);
  }
  return $self;
}

sub abs
{
  my $self=shift;
  my $obj = $self->SUPER::abs(@_);
  $obj->[2]=$self->deep();
  $obj->[3]=$self->parent();
  return $obj;
}

sub clone
{
  my $self=shift;
  my $obj = $self->SUPER::clone(@_);
  $obj->[2]=$self->deep();
  $obj->[3]=$self->parent();
  return $obj;
}

sub rel
{
  my $self=shift;
  my $obj = $self->SUPER::rel(@_);
  $obj->[2]=$self->deep();
  $obj->[3]=$self->parent();
  return $obj;
}

########################################################################
# new
sub deep
{
  my $self=shift;
  my $deep=shift;
  if(defined($deep) && $deep=~/^\d+$/)
  { $self->[2]=$deep; }
  return $self->[2];
}

sub parent
{
  my $self=shift;
  my $url=shift;
  if(defined($url))
  {
    # Objekt auflösen um mögliche Rekursionen der Refenzen zu vermeiden
    if(ref($url) eq __PACKAGE__)
    {
      $url=$url->abs();
      $url=$url->as_string;
    }
    #print "PARENT-URL:".Dumper($url);
    $self->[3]=$url;
  }
  return $self->[3];
}

1;
